#![allow(deprecated)]
use std::fmt;
use std::str;
/// Supported ingest types for containerized extractor outputs.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ManifestIngestType {
    #[serde(rename = "TABULAR")]
    Tabular,
    #[serde(rename = "AVRO_STREAM")]
    AvroStream,
    #[serde(rename = "JSON_L")]
    JsonL,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ManifestIngestType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ManifestIngestType::Tabular => "TABULAR",
            ManifestIngestType::AvroStream => "AVRO_STREAM",
            ManifestIngestType::JsonL => "JSON_L",
            ManifestIngestType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ManifestIngestType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ManifestIngestType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ManifestIngestType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ManifestIngestType, conjure_object::plain::ParseEnumError> {
        match v {
            "TABULAR" => Ok(ManifestIngestType::Tabular),
            "AVRO_STREAM" => Ok(ManifestIngestType::AvroStream),
            "JSON_L" => Ok(ManifestIngestType::JsonL),
            v => v.parse().map(|v| ManifestIngestType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ManifestIngestType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ManifestIngestType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ManifestIngestType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
